import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))  # Undirected graph

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)

    def bfs(start_node):
        queue = collections.deque([(start_node, 0)])
        visited = {start_node}
        distances = {}
        distances[start_node] = 0

        while queue:
            curr_node, dist = queue.popleft()
            for neighbor in graph[curr_node]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, dist + 1))
                    distances[neighbor] = dist + 1
        return distances

    guarded_warehouses = set()
    for guard_pos, guard_range in guards:
        distances_from_guard = bfs(guard_pos)
        for warehouse, dist in distances_from_guard.items():
            if dist <= guard_range:
                guarded_warehouses.add(warehouse)

    guarded_warehouses_list = sorted(list(guarded_warehouses))
    print(len(guarded_warehouses_list))
    if guarded_warehouses_list:
        print(*guarded_warehouses_list)
    else:
        print()

solve()

