import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))  # Undirected graph

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)

    def bfs(start_node):
        q = collections.deque([(start_node, 0)])
        visited = {start_node}
        dists = {start_node: 0}

        while q:
            curr, dist = q.popleft()
            for neighbor in graph[curr]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    q.append((neighbor, dist + 1))
                    dists[neighbor] = dist + 1
        return dists

    guarded = set()
    for guard_node, guard_range in guards:
        dists = bfs(guard_node)
        for node, dist in dists.items():
            if dist <= guard_range:
                guarded.add(node)

    guarded_list = sorted(list(guarded))
    print(len(guarded_list))
    print(*guarded_list) if guarded_list else print()

solve()

